ConvergentFacet Class

class NXOpen.ConvergentFacet

Bases: NXOpen.IFacet

Represents a facet from convergent topology.

Instances of this class can be created using methods on NXOpen.Body and NXOpen.Face .. versionadded:: NX11.0.2

Properties

Property Description
FacetIdentifier Returns the indentifier of facet in its owning entity
IsOccurrence Returns whether this object is an occurrence or not.
IsValid Returns whether or not the convergent facet is a valid facet.
JournalIdentifier Returns the identifier that would be recorded in a journal for this object.
Name Returns the custom name of the object.
OwningComponent Returns the owning component, if this object is an occurrence.
OwningFace Returns the owning face of convergent facet.
OwningPart Returns the owning part of this object
Prototype Returns the prototype of this object if it is an occurrence.
Tag Returns the Tag for this object.
Vertex0 Returns or sets the coordinates of the vertex with index equal to zero.
Vertex1 Returns or sets the coordinates of the vertex with index equal to one.
Vertex2 Returns or sets the coordinates of the vertex with index equal to two.

Methods

Method Description
CreateAttributeIterator Create an attribute iterator
DeleteAllAttributesByType Deletes all attributes of a specific type.
DeleteAttributeByTypeAndTitle Deletes an attribute by type and title.
DeleteUserAttribute Deletes the first attribute encountered with the given Type, Title.
DeleteUserAttributes Deletes the attributes on the object, if any, that satisfy the given iterator
Destroy Deletes a convergent facet object.
FindObject Finds the NXOpen.NXObject with the given identifier as recorded in a journal.
GetAdjacentFacet Returns adjacent facet of a facet that abuts along edge of given edge index.
GetAttributeTitlesByType Gets all the attribute titles of a specific type.
GetBooleanUserAttribute Gets a boolean attribute by Title and array Index.
GetComputationalTimeUserAttribute Gets a time attribute by Title and array Index.
GetIntegerAttribute Gets an integer attribute by title.
GetIntegerUserAttribute Gets an integer attribute by Title and array Index.
GetNextUserAttribute Gets the next attribute encountered on the object, if any, that satisfies the given iterator.
GetPdmReferenceAttributeValue Gets the value of PDM Reference attribute for given object.
GetPlaneEquation Returns coefficients of plane equation of a convergent facet.
GetRealAttribute Gets a real attribute by title.
GetRealUserAttribute Gets a real attribute by Title and array Index.
GetReferenceAttribute Gets the reference string (not the calculated value) of a string attribute that uses a reference string.
GetStringAttribute Gets a string attribute value by title.
GetStringUserAttribute Gets a string attribute by Title and array Index.
GetTimeAttribute Gets a time attribute by title.
GetTimeUserAttribute Gets a time attribute by Title and array Index.
GetUnitNormal Returns unit normal vector of convergent facet.
GetUserAttribute Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index.
GetUserAttributeAsString Gets the first attribute encountered on the object, if any, with a given title, type and array index.
GetUserAttributeCount Gets the count of set attributes on the object, if any, that satisfy the given iterator.
GetUserAttributeLock Determine the lock of the given attribute.
GetUserAttributeSize Gets the size of the first attribute encountered on the object, if any, with a given Title and Type.
GetUserAttributeSourceObjects Returns an array of objects from which this object presents attributes.
GetUserAttributes Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator.
GetUserAttributesAsStrings Gets all the attributes that have been set on the given object.
GetVertexNormals Returns unit vertex normals of convergent facet.
GetVertices Returns all three vertices of convergent facet in an array of points.
HasUserAttribute Determines if an attribute exists on the object, that satisfies the given iterator
Print Prints a representation of this object to the system log file.
SetAttribute Creates or modifies an integer attribute.
SetBooleanUserAttribute Creates or modifies a boolean attribute with the option to update or not.
SetName Sets the custom name of the object.
SetPdmReferenceAttribute Sets the value of PDM Reference attribute on the object.
SetReferenceAttribute Creates or modifies a string attribute which uses a reference string.
SetTimeAttribute Creates or modifies a time attribute.
SetTimeUserAttribute Creates or modifies a time attribute with the option to update or not.
SetUserAttribute Creates or modifies an attribute with the option to update or not.
SetUserAttributeLock Lock or unlock the given attribute.
SetVertices Sets the coordinates of all the three vertices of a convergent facet to new values.

Property Detail

IsOccurrence

ConvergentFacet.IsOccurrence

Returns whether this object is an occurrence or not.

-------------------------------------

Getter Method

Signature IsOccurrence

Returns:This object is an occurrence
Return type:bool

New in version NX3.0.0.

License requirements: None.

IsValid

ConvergentFacet.IsValid

Returns whether or not the convergent facet is a valid facet.

A facet becomes invalid when the underlying surface undergoes an update such that the given facet is no longer present in its surface.

-------------------------------------

Getter Method

Signature IsValid

Returns:True if convergent facet is valid for querying the information.
Return type:bool

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

JournalIdentifier

ConvergentFacet.JournalIdentifier

Returns the identifier that would be recorded in a journal for this object.

This may not be the same across different releases of the software.

-------------------------------------

Getter Method

Signature JournalIdentifier

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

Name

ConvergentFacet.Name

Returns the custom name of the object.

-------------------------------------

Getter Method

Signature Name

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

OwningComponent

ConvergentFacet.OwningComponent

Returns the owning component, if this object is an occurrence.

-------------------------------------

Getter Method

Signature OwningComponent

Returns:
Return type:NXOpen.Assemblies.Component

New in version NX3.0.0.

License requirements: None.

OwningFace

ConvergentFacet.OwningFace

Returns the owning face of convergent facet.

-------------------------------------

Getter Method

Signature OwningFace

Returns:The convergent face in which a facet resides.
Return type:NXOpen.Face

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

OwningPart

ConvergentFacet.OwningPart

Returns the owning part of this object

-------------------------------------

Getter Method

Signature OwningPart

Returns:The owning part of this object or null if it does not have an owner
Return type:NXOpen.BasePart

New in version NX3.0.0.

License requirements: None.

Prototype

ConvergentFacet.Prototype

Returns the prototype of this object if it is an occurrence.

-------------------------------------

Getter Method

Signature Prototype

Returns:The prototype of this object or null if this object is not an occurrence
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

Vertex0

ConvergentFacet.Vertex0

Returns or sets the coordinates of the vertex with index equal to zero.

Please note that the set method repositions the facet vertices only if the vertex meets the following requirements:

  1. The vertex does not lie on a boundary edge of the convergent body.
  2. The vertex belongs to a dumb body feature without any dependent feature that modifies the body.

This method should be followed by a subsequent call to NXOpen.Update.DoUpdate(). If your application sets multiple vertices of a face, then NXOpen.Update.DoUpdate() should be called only once after setting all the vertices to new coordinates.

If any of the vertices of this facet lie on a boundary edge, then an exception with error code 4186254 is raised. If this facet belongs to a body feature that has dependent features and not just a dumb body feature, then an exception with error code 4186253 is raised.

-------------------------------------

Getter Method

Signature Vertex0

Returns:vertex of zeroth index
Return type:NXOpen.Point3d

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

-------------------------------------

Setter Method

Signature Vertex0

Parameters:point (NXOpen.Point3d) – vertex of zeroth index

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

Vertex1

ConvergentFacet.Vertex1

Returns or sets the coordinates of the vertex with index equal to one.

Please note that the set method repositions the facet vertices only if the vertex meets the following requirements:

  1. The vertex does not lie on a boundary edge of the convergent body.
  2. The vertex belongs to a dumb body feature without any dependent feature that modifies the body.

This method should be followed by a subsequent call to NXOpen.Update.DoUpdate(). If your application sets multiple vertices of a face, then NXOpen.Update.DoUpdate() should be called only once after setting all the vertices to new coordinates.

If any of the vertices of this facet lie on a boundary edge, then an exception with error code 4186254 is raised. If this facet belongs to a body feature that has dependent features and not just a dumb body feature, then an exception with error code 4186253 is raised.

-------------------------------------

Getter Method

Signature Vertex1

Returns:vertex of first index
Return type:NXOpen.Point3d

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

-------------------------------------

Setter Method

Signature Vertex1

Parameters:point (NXOpen.Point3d) – vertex of first index

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

Vertex2

ConvergentFacet.Vertex2

Returns or sets the coordinates of the vertex with index equal to two.

Please note that the set method repositions the facet vertices only if the vertex meets the following requirements:

  1. The vertex does not lie on a boundary edge of the convergent body.
  2. The vertex belongs to a dumb body feature without any dependent feature that modifies the body.

This method should be followed by a subsequent call to NXOpen.Update.DoUpdate(). If your application sets multiple vertices of a face, then NXOpen.Update.DoUpdate() should be called only once after setting all the vertices to new coordinates.

If any of the vertices of this facet lie on a boundary edge, then an exception with error code 4186254 is raised. If this facet belongs to a body feature that has dependent features and not just a dumb body feature, then an exception with error code 4186253 is raised.

-------------------------------------

Getter Method

Signature Vertex2

Returns:vertex of second index
Return type:NXOpen.Point3d

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

-------------------------------------

Setter Method

Signature Vertex2

Parameters:point (NXOpen.Point3d) – vertex of second index

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

Method Detail

Destroy

ConvergentFacet.Destroy

Deletes a convergent facet object.

Please note that this method does not geometrically delete a facet from its surface mesh leaving a hole. It only deletes the tagged object created to represent the individual facet. If you are dealing with a large number of facets in your application, use this method to delete the facet when you are finished working with it.

Signature Destroy()

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

FindObject

ConvergentFacet.FindObject

Finds the NXOpen.NXObject with the given identifier as recorded in a journal.

An object may not return the same value as its JournalIdentifier in different versions of the software. However newer versions of the software should find the same object when FindObject is passed older versions of its journal identifier. In general, this method should not be used in handwritten code and exists to support record and playback of journals.

An exception will be thrown if no object can be found with the given journal identifier.

Signature FindObject(journalIdentifier)

Parameters:journalIdentifier (str) – Journal identifier of the object
Returns:
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

GetAdjacentFacet

ConvergentFacet.GetAdjacentFacet

Returns adjacent facet of a facet that abuts along edge of given edge index.

If edge of given edgeIndex is on boundary of the face, then a None is returned.

Signature GetAdjacentFacet(edgeIndex)

Parameters:edgeIndex (int) – the index of edge at which adjacent facet is to find. It can be 0, 1 or 2. Error is returned for invalid value of edge index.
Returns:The adjacent facet along edge of input index
Return type:NXOpen.ConvergentFacet

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

GetPlaneEquation

ConvergentFacet.GetPlaneEquation

Returns coefficients of plane equation of a convergent facet.

The equation is of the form Ax + By +Cz + D = 0. Three values contained in parameter planeNormal represent A, B and C coefficients of the equation. dCoefficient represents D coefficient of the equation.

Signature GetPlaneEquation()

Returns:a tuple
Return type:A tuple consisting of (planeNormal, dCoefficient). planeNormal is a NXOpen.Vector3d. The plane unit normal for the facet. The (X, Y, Z) of this vector provide the A, B and C coefficients respectively of the plane equation. dCoefficient is a float. provides the D coefficient in the plane equation.

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

GetUnitNormal

ConvergentFacet.GetUnitNormal

Returns unit normal vector of convergent facet.

The unit normal of a facet depends on vertex ordering within facet and generally is in the direction of face normal. For a solid convergent body, the facet unit normal points away from the material if underlying surface is attached to the face in positive sense and vice versa.

Signature GetUnitNormal()

Returns:The unit normal vector
Return type:NXOpen.Vector3d

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

GetVertexNormals

ConvergentFacet.GetVertexNormals

Returns unit vertex normals of convergent facet.

Signature GetVertexNormals()

Returns:The array of three vectors containing unit vertex normals at each facet vertex.
Return type:list of NXOpen.Vector3d

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

GetVertices

ConvergentFacet.GetVertices

Returns all three vertices of convergent facet in an array of points.

Signature GetVertices()

Returns:The point array of three elements representing vertices of a convergent facet.
Return type:list of NXOpen.Point3d

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)

Print

ConvergentFacet.Print

Prints a representation of this object to the system log file.

Signature Print()

New in version NX3.0.0.

License requirements: None.

SetName

ConvergentFacet.SetName

Sets the custom name of the object.

NOTE: This method should not be used to edit a read-only object such as a Mirrored PMI object. If it is, the changes will be overridden when the part is updated.

Signature SetName(name)

Parameters:name (str) –

New in version NX3.0.0.

License requirements: None.

SetVertices

ConvergentFacet.SetVertices

Sets the coordinates of all the three vertices of a convergent facet to new values.

Please note that the set method repositions the facet vertices only if the vertex meets the following requirements:

  1. The vertex does not lie on a boundary edge of the convergent body.
  2. The vertex belongs to a dumb body feature without any dependent feature that modifies the body.

This method should be followed by a subsequent call to NXOpen.Update.DoUpdate(). If your application sets multiple vertices of a face, then NXOpen.Update.DoUpdate() should be called only once after setting all the vertices to new coordinates.

If any of the vertices of this facet lie on a boundary edge, then an exception with error code 4186254 is raised. If this facet belongs to a body feature that has dependent features and not just a dumb body feature, then an exception with error code 4186253 is raised.

Signature SetVertices(points)

Parameters:points (list of NXOpen.Point3d) –

New in version NX11.0.2.

License requirements: gateway (“UG GATEWAY”)